searchData={"items":[{"type":"module","title":"Surrealix","doc":"","ref":"Surrealix.html"},{"type":"function","title":"Surrealix.authenticate/2","doc":"authenticate [ token ]\n  This method allows you to authenticate a user against SurrealDB with a token\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"authenticate\",\n    \"params\": [\n      \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.html#authenticate/2"},{"type":"function","title":"Surrealix.authenticate/3","doc":"","ref":"Surrealix.html#authenticate/3"},{"type":"function","title":"Surrealix.authenticate/4","doc":"","ref":"Surrealix.html#authenticate/4"},{"type":"function","title":"Surrealix.create/3","doc":"create [ thing, data ]\n  This method creates a record either with a random or specified ID\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"create\",\n    \"params\": [\n      \"person\",\n      {\n        \"name\": \"Mary Doe\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n        \"name\": \"Mary Doe\"\n      }\n    ]\n  }","ref":"Surrealix.html#create/3"},{"type":"function","title":"Surrealix.create/4","doc":"","ref":"Surrealix.html#create/4"},{"type":"function","title":"Surrealix.create/5","doc":"","ref":"Surrealix.html#create/5"},{"type":"function","title":"Surrealix.delete/2","doc":"delete [ thing ]\n  This method deletes either all records in a table or a single record\n  NOTE: Notice how the deleted record is being returned here\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"delete\",\n    \"params\": [\n      \"person:8s0j0bbm3ngrd5c9bx53\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": {\n      \"active\": true,\n      \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n      \"last_updated\": \"2023-06-16T08:34:25Z\",\n      \"name\": \"John Doe\"\n    }\n  }","ref":"Surrealix.html#delete/2"},{"type":"function","title":"Surrealix.delete/3","doc":"","ref":"Surrealix.html#delete/3"},{"type":"function","title":"Surrealix.delete/4","doc":"","ref":"Surrealix.html#delete/4"},{"type":"function","title":"Surrealix.info/1","doc":"info\n  This method returns the record of an authenticated scope user.\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"info\"\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": {\n      \"id\": \"user:john\",\n      \"name\": \"John Doe\"\n    }\n  }","ref":"Surrealix.html#info/1"},{"type":"function","title":"Surrealix.insert/3","doc":"insert [ thing, data ]\n  This method creates a record either with a random or specified ID\n  Single insert\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"insert\",\n    \"params\": [\n      \"person\",\n      {\n        \"name\": \"Mary Doe\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n        \"name\": \"Mary Doe\"\n      }\n    ]\n  }\n  Bulk insert\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"insert\",\n    \"params\": [\n      \"person\",\n      [\n        {\n          \"name\": \"Mary Doe\"\n        },\n        {\n          \"name\": \"John Doe\"\n        }\n      ]\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n        \"name\": \"Mary Doe\"\n      },\n      {\n        \"id\": \"person:xtbbojcm82a97vus9x0j\",\n        \"name\": \"John Doe\"\n      }\n    ]\n  }","ref":"Surrealix.html#insert/3"},{"type":"function","title":"Surrealix.insert/4","doc":"","ref":"Surrealix.html#insert/4"},{"type":"function","title":"Surrealix.insert/5","doc":"","ref":"Surrealix.html#insert/5"},{"type":"function","title":"Surrealix.invalidate/1","doc":"invalidate\n  This method will invalidate the user's session for the current connection\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"invalidate\"\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.html#invalidate/1"},{"type":"function","title":"Surrealix.kill/2","doc":"kill [ queryUuid ]\n  This methods kills an active live query\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"kill\",\n    \"params\": [\n      \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.html#kill/2"},{"type":"function","title":"Surrealix.kill/3","doc":"","ref":"Surrealix.html#kill/3"},{"type":"function","title":"Surrealix.kill/4","doc":"","ref":"Surrealix.html#kill/4"},{"type":"function","title":"Surrealix.let/3","doc":"let [ name, value ]\n  This method stores a variable on the current connection\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"let\",\n    \"params\": [\n      \"website\",\n      \"https://surrealdb.com/\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.html#let/3"},{"type":"function","title":"Surrealix.let/4","doc":"","ref":"Surrealix.html#let/4"},{"type":"function","title":"Surrealix.let/5","doc":"","ref":"Surrealix.html#let/5"},{"type":"function","title":"Surrealix.live/3","doc":"live [ table ]\n  This methods initiates a live query for a specified table name\n  NOTE: For more advanced live queries where filters are needed, use the Query method to initiate a custom live query.\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"live\",\n    \"params\": [\n      \"person\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n  }\n  Live notification\n\n  Example request:\n  {}\n\n  Example response:\n  {\n    \"result\": {\n      \"action\": \"CREATE\",\n      \"id\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\",\n      \"result\": {\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"name\": \"John\"\n      }\n    }\n  }","ref":"Surrealix.html#live/3"},{"type":"function","title":"Surrealix.live/4","doc":"","ref":"Surrealix.html#live/4"},{"type":"function","title":"Surrealix.live/5","doc":"","ref":"Surrealix.html#live/5"},{"type":"function","title":"Surrealix.merge/3","doc":"merge [ thing, data ]\n  This method merges specified data into either all records in a table or a single record\n  NOTE: This function merges the current document / record data with the specified data. If no merge data is passed it will simply trigger an update.\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"merge\",\n    \"params\": [\n      \"person\",\n      {\n        \"active\": true\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"active\": true,\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"name\": \"John Doe\"\n      },\n      {\n        \"active\": true,\n        \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n        \"name\": \"Mary Doe\"\n      }\n    ]\n  }","ref":"Surrealix.html#merge/3"},{"type":"function","title":"Surrealix.merge/4","doc":"","ref":"Surrealix.html#merge/4"},{"type":"function","title":"Surrealix.merge/5","doc":"","ref":"Surrealix.html#merge/5"},{"type":"function","title":"Surrealix.patch/4","doc":"patch [ thing, patches, diff ]\n  This method patches either all records in a table or a single record with specified patches\n  NOTE: This function patches the current document / record data with the specified JSON Patch data.\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"patch\",\n    \"params\": [\n      \"person\",\n      [\n        {\n          \"op\": \"replace\",\n          \"path\": \"/last_updated\",\n          \"value\": \"2023-06-16T08:34:25Z\"\n        }\n      ]\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      [\n        {\n          \"op\": \"add\",\n          \"path\": \"/last_updated\",\n          \"value\": \"2023-06-16T08:34:25Z\"\n        }\n      ],\n      [\n        {\n          \"op\": \"add\",\n          \"path\": \"/last_updated\",\n          \"value\": \"2023-06-16T08:34:25Z\"\n        }\n      ]\n    ]\n  }","ref":"Surrealix.html#patch/4"},{"type":"function","title":"Surrealix.patch/5","doc":"","ref":"Surrealix.html#patch/5"},{"type":"function","title":"Surrealix.patch/6","doc":"","ref":"Surrealix.html#patch/6"},{"type":"function","title":"Surrealix.ping/1","doc":"ping\n  This method pings the SurrealDB instance\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"ping\"\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.html#ping/1"},{"type":"function","title":"Surrealix.query/3","doc":"query [ sql, vars ]\n  This method executes a custom query against SurrealDB\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"query\",\n    \"params\": [\n      \"CREATE person SET name = 'John'; SELECT * FROM type::table($tb);\",\n      {\n        \"tb\": \"person\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"status\": \"OK\",\n        \"time\": \"152.5µs\",\n        \"result\": [\n          {\n            \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n            \"name\": \"John\"\n          }\n        ]\n      },\n      {\n        \"status\": \"OK\",\n        \"time\": \"32.375µs\",\n        \"result\": [\n          {\n            \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n            \"name\": \"John\"\n          }\n        ]\n      }\n    ]\n  }","ref":"Surrealix.html#query/3"},{"type":"function","title":"Surrealix.query/4","doc":"","ref":"Surrealix.html#query/4"},{"type":"function","title":"Surrealix.query/5","doc":"","ref":"Surrealix.html#query/5"},{"type":"function","title":"Surrealix.select/2","doc":"select [ thing ]\n  This method selects either all records in a table or a single record\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"select\",\n    \"params\": [\n      \"person\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"name\": \"John\"\n      }\n    ]\n  }","ref":"Surrealix.html#select/2"},{"type":"function","title":"Surrealix.select/3","doc":"","ref":"Surrealix.html#select/3"},{"type":"function","title":"Surrealix.select/4","doc":"","ref":"Surrealix.html#select/4"},{"type":"function","title":"Surrealix.signin/2","doc":"signin [ NS, DB, SC, ... ]\n  This method allows you to signin a root, NS, DB or SC user against SurrealDB\n  As Root\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"signin\",\n    \"params\": [\n      {\n        \"user\": \"tobie\",\n        \"pass\": \"3xtr3m3ly-s3cur3-p@ssw0rd\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }\n  Signin as scope\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"signin\",\n    \"params\": [\n      {\n        \"NS\": \"surrealdb\",\n        \"DB\": \"docs\",\n        \"SC\": \"commenter\",\n        \"username\": \"johndoe\",\n        \"password\": \"SuperStrongPassword!\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n  }","ref":"Surrealix.html#signin/2"},{"type":"function","title":"Surrealix.signin/3","doc":"","ref":"Surrealix.html#signin/3"},{"type":"function","title":"Surrealix.signin/4","doc":"","ref":"Surrealix.html#signin/4"},{"type":"function","title":"Surrealix.signup/2","doc":"signup [ NS, DB, SC, ... ]\n  This method allows you to signup a user against a scope's SIGNUP method\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"signup\",\n    \"params\": [\n      {\n        \"NS\": \"surrealdb\",\n        \"DB\": \"docs\",\n        \"SC\": \"commenter\",\n        \"username\": \"johndoe\",\n        \"password\": \"SuperStrongPassword!\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n  }","ref":"Surrealix.html#signup/2"},{"type":"function","title":"Surrealix.signup/3","doc":"","ref":"Surrealix.html#signup/3"},{"type":"function","title":"Surrealix.signup/4","doc":"","ref":"Surrealix.html#signup/4"},{"type":"function","title":"Surrealix.start_link/0","doc":"","ref":"Surrealix.html#start_link/0"},{"type":"function","title":"Surrealix.start_link/1","doc":"","ref":"Surrealix.html#start_link/1"},{"type":"function","title":"Surrealix.stop/1","doc":"","ref":"Surrealix.html#stop/1"},{"type":"function","title":"Surrealix.unset/2","doc":"unset [ name ]\n  This method removes a variable from the current connection\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"unset\",\n    \"params\": [\n      \"website\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.html#unset/2"},{"type":"function","title":"Surrealix.unset/3","doc":"","ref":"Surrealix.html#unset/3"},{"type":"function","title":"Surrealix.unset/4","doc":"","ref":"Surrealix.html#unset/4"},{"type":"function","title":"Surrealix.update/3","doc":"update [ thing, data ]\n  This method replaces either all records in a table or a single record with specified data\n  NOTE: This function replaces the current document / record data with the specified data. If no replacement data is passed it will simply trigger an update.\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"update\",\n    \"params\": [\n      \"person:8s0j0bbm3ngrd5c9bx53\",\n      {\n        \"name\": \"John Doe\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": {\n      \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n      \"name\": \"John Doe\"\n    }\n  }","ref":"Surrealix.html#update/3"},{"type":"function","title":"Surrealix.update/4","doc":"","ref":"Surrealix.html#update/4"},{"type":"function","title":"Surrealix.update/5","doc":"","ref":"Surrealix.html#update/5"},{"type":"function","title":"Surrealix.use/3","doc":"use [ ns, db ]\n  Specifies the namespace and database for the current connection\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"use\",\n    \"params\": [\n      \"surrealdb\",\n      \"docs\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.html#use/3"},{"type":"function","title":"Surrealix.use/4","doc":"","ref":"Surrealix.html#use/4"},{"type":"function","title":"Surrealix.use/5","doc":"","ref":"Surrealix.html#use/5"},{"type":"module","title":"Surrealix.Socket","doc":"","ref":"Surrealix.Socket.html"},{"type":"function","title":"Surrealix.Socket.authenticate/2","doc":"authenticate [ token ]\n  This method allows you to authenticate a user against SurrealDB with a token\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"authenticate\",\n    \"params\": [\n      \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.Socket.html#authenticate/2"},{"type":"function","title":"Surrealix.Socket.authenticate/4","doc":"","ref":"Surrealix.Socket.html#authenticate/4"},{"type":"function","title":"Surrealix.Socket.create/3","doc":"create [ thing, data ]\n  This method creates a record either with a random or specified ID\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"create\",\n    \"params\": [\n      \"person\",\n      {\n        \"name\": \"Mary Doe\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n        \"name\": \"Mary Doe\"\n      }\n    ]\n  }","ref":"Surrealix.Socket.html#create/3"},{"type":"function","title":"Surrealix.Socket.create/5","doc":"","ref":"Surrealix.Socket.html#create/5"},{"type":"function","title":"Surrealix.Socket.delete/2","doc":"delete [ thing ]\n  This method deletes either all records in a table or a single record\n  NOTE: Notice how the deleted record is being returned here\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"delete\",\n    \"params\": [\n      \"person:8s0j0bbm3ngrd5c9bx53\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": {\n      \"active\": true,\n      \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n      \"last_updated\": \"2023-06-16T08:34:25Z\",\n      \"name\": \"John Doe\"\n    }\n  }","ref":"Surrealix.Socket.html#delete/2"},{"type":"function","title":"Surrealix.Socket.delete/4","doc":"","ref":"Surrealix.Socket.html#delete/4"},{"type":"function","title":"Surrealix.Socket.info/1","doc":"info\n  This method returns the record of an authenticated scope user.\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"info\"\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": {\n      \"id\": \"user:john\",\n      \"name\": \"John Doe\"\n    }\n  }","ref":"Surrealix.Socket.html#info/1"},{"type":"function","title":"Surrealix.Socket.info/3","doc":"","ref":"Surrealix.Socket.html#info/3"},{"type":"function","title":"Surrealix.Socket.insert/3","doc":"insert [ thing, data ]\n  This method creates a record either with a random or specified ID\n  Single insert\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"insert\",\n    \"params\": [\n      \"person\",\n      {\n        \"name\": \"Mary Doe\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n        \"name\": \"Mary Doe\"\n      }\n    ]\n  }\n  Bulk insert\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"insert\",\n    \"params\": [\n      \"person\",\n      [\n        {\n          \"name\": \"Mary Doe\"\n        },\n        {\n          \"name\": \"John Doe\"\n        }\n      ]\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n        \"name\": \"Mary Doe\"\n      },\n      {\n        \"id\": \"person:xtbbojcm82a97vus9x0j\",\n        \"name\": \"John Doe\"\n      }\n    ]\n  }","ref":"Surrealix.Socket.html#insert/3"},{"type":"function","title":"Surrealix.Socket.insert/5","doc":"","ref":"Surrealix.Socket.html#insert/5"},{"type":"function","title":"Surrealix.Socket.invalidate/1","doc":"invalidate\n  This method will invalidate the user's session for the current connection\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"invalidate\"\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.Socket.html#invalidate/1"},{"type":"function","title":"Surrealix.Socket.invalidate/3","doc":"","ref":"Surrealix.Socket.html#invalidate/3"},{"type":"function","title":"Surrealix.Socket.kill/2","doc":"kill [ queryUuid ]\n  This methods kills an active live query\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"kill\",\n    \"params\": [\n      \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.Socket.html#kill/2"},{"type":"function","title":"Surrealix.Socket.kill/4","doc":"","ref":"Surrealix.Socket.html#kill/4"},{"type":"function","title":"Surrealix.Socket.let/3","doc":"let [ name, value ]\n  This method stores a variable on the current connection\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"let\",\n    \"params\": [\n      \"website\",\n      \"https://surrealdb.com/\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.Socket.html#let/3"},{"type":"function","title":"Surrealix.Socket.let/5","doc":"","ref":"Surrealix.Socket.html#let/5"},{"type":"function","title":"Surrealix.Socket.live/3","doc":"live [ table ]\n  This methods initiates a live query for a specified table name\n  NOTE: For more advanced live queries where filters are needed, use the Query method to initiate a custom live query.\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"live\",\n    \"params\": [\n      \"person\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n  }\n  Live notification\n\n  Example request:\n  {}\n\n  Example response:\n  {\n    \"result\": {\n      \"action\": \"CREATE\",\n      \"id\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\",\n      \"result\": {\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"name\": \"John\"\n      }\n    }\n  }","ref":"Surrealix.Socket.html#live/3"},{"type":"function","title":"Surrealix.Socket.live/5","doc":"","ref":"Surrealix.Socket.html#live/5"},{"type":"function","title":"Surrealix.Socket.merge/3","doc":"merge [ thing, data ]\n  This method merges specified data into either all records in a table or a single record\n  NOTE: This function merges the current document / record data with the specified data. If no merge data is passed it will simply trigger an update.\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"merge\",\n    \"params\": [\n      \"person\",\n      {\n        \"active\": true\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"active\": true,\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"name\": \"John Doe\"\n      },\n      {\n        \"active\": true,\n        \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n        \"name\": \"Mary Doe\"\n      }\n    ]\n  }","ref":"Surrealix.Socket.html#merge/3"},{"type":"function","title":"Surrealix.Socket.merge/5","doc":"","ref":"Surrealix.Socket.html#merge/5"},{"type":"function","title":"Surrealix.Socket.patch/4","doc":"patch [ thing, patches, diff ]\n  This method patches either all records in a table or a single record with specified patches\n  NOTE: This function patches the current document / record data with the specified JSON Patch data.\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"patch\",\n    \"params\": [\n      \"person\",\n      [\n        {\n          \"op\": \"replace\",\n          \"path\": \"/last_updated\",\n          \"value\": \"2023-06-16T08:34:25Z\"\n        }\n      ]\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      [\n        {\n          \"op\": \"add\",\n          \"path\": \"/last_updated\",\n          \"value\": \"2023-06-16T08:34:25Z\"\n        }\n      ],\n      [\n        {\n          \"op\": \"add\",\n          \"path\": \"/last_updated\",\n          \"value\": \"2023-06-16T08:34:25Z\"\n        }\n      ]\n    ]\n  }","ref":"Surrealix.Socket.html#patch/4"},{"type":"function","title":"Surrealix.Socket.patch/6","doc":"","ref":"Surrealix.Socket.html#patch/6"},{"type":"function","title":"Surrealix.Socket.ping/1","doc":"ping\n  This method pings the SurrealDB instance\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"ping\"\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.Socket.html#ping/1"},{"type":"function","title":"Surrealix.Socket.ping/3","doc":"","ref":"Surrealix.Socket.html#ping/3"},{"type":"function","title":"Surrealix.Socket.query/3","doc":"query [ sql, vars ]\n  This method executes a custom query against SurrealDB\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"query\",\n    \"params\": [\n      \"CREATE person SET name = 'John'; SELECT * FROM type::table($tb);\",\n      {\n        \"tb\": \"person\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"status\": \"OK\",\n        \"time\": \"152.5µs\",\n        \"result\": [\n          {\n            \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n            \"name\": \"John\"\n          }\n        ]\n      },\n      {\n        \"status\": \"OK\",\n        \"time\": \"32.375µs\",\n        \"result\": [\n          {\n            \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n            \"name\": \"John\"\n          }\n        ]\n      }\n    ]\n  }","ref":"Surrealix.Socket.html#query/3"},{"type":"function","title":"Surrealix.Socket.query/5","doc":"","ref":"Surrealix.Socket.html#query/5"},{"type":"function","title":"Surrealix.Socket.select/2","doc":"select [ thing ]\n  This method selects either all records in a table or a single record\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"select\",\n    \"params\": [\n      \"person\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": [\n      {\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"name\": \"John\"\n      }\n    ]\n  }","ref":"Surrealix.Socket.html#select/2"},{"type":"function","title":"Surrealix.Socket.select/4","doc":"","ref":"Surrealix.Socket.html#select/4"},{"type":"function","title":"Surrealix.Socket.signin/2","doc":"signin [ NS, DB, SC, ... ]\n  This method allows you to signin a root, NS, DB or SC user against SurrealDB\n  As Root\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"signin\",\n    \"params\": [\n      {\n        \"user\": \"tobie\",\n        \"pass\": \"3xtr3m3ly-s3cur3-p@ssw0rd\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }\n  Signin as scope\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"signin\",\n    \"params\": [\n      {\n        \"NS\": \"surrealdb\",\n        \"DB\": \"docs\",\n        \"SC\": \"commenter\",\n        \"username\": \"johndoe\",\n        \"password\": \"SuperStrongPassword!\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n  }","ref":"Surrealix.Socket.html#signin/2"},{"type":"function","title":"Surrealix.Socket.signin/4","doc":"","ref":"Surrealix.Socket.html#signin/4"},{"type":"function","title":"Surrealix.Socket.signup/2","doc":"signup [ NS, DB, SC, ... ]\n  This method allows you to signup a user against a scope's SIGNUP method\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"signup\",\n    \"params\": [\n      {\n        \"NS\": \"surrealdb\",\n        \"DB\": \"docs\",\n        \"SC\": \"commenter\",\n        \"username\": \"johndoe\",\n        \"password\": \"SuperStrongPassword!\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n  }","ref":"Surrealix.Socket.html#signup/2"},{"type":"function","title":"Surrealix.Socket.signup/4","doc":"","ref":"Surrealix.Socket.html#signup/4"},{"type":"function","title":"Surrealix.Socket.start_link/1","doc":"","ref":"Surrealix.Socket.html#start_link/1"},{"type":"function","title":"Surrealix.Socket.stop/1","doc":"","ref":"Surrealix.Socket.html#stop/1"},{"type":"function","title":"Surrealix.Socket.unset/2","doc":"unset [ name ]\n  This method removes a variable from the current connection\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"unset\",\n    \"params\": [\n      \"website\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.Socket.html#unset/2"},{"type":"function","title":"Surrealix.Socket.unset/4","doc":"","ref":"Surrealix.Socket.html#unset/4"},{"type":"function","title":"Surrealix.Socket.update/3","doc":"update [ thing, data ]\n  This method replaces either all records in a table or a single record with specified data\n  NOTE: This function replaces the current document / record data with the specified data. If no replacement data is passed it will simply trigger an update.\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"update\",\n    \"params\": [\n      \"person:8s0j0bbm3ngrd5c9bx53\",\n      {\n        \"name\": \"John Doe\"\n      }\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": {\n      \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n      \"name\": \"John Doe\"\n    }\n  }","ref":"Surrealix.Socket.html#update/3"},{"type":"function","title":"Surrealix.Socket.update/5","doc":"","ref":"Surrealix.Socket.html#update/5"},{"type":"function","title":"Surrealix.Socket.use/3","doc":"use [ ns, db ]\n  Specifies the namespace and database for the current connection\n\n  Example request:\n  {\n    \"id\": 1,\n    \"method\": \"use\",\n    \"params\": [\n      \"surrealdb\",\n      \"docs\"\n    ]\n  }\n\n  Example response:\n  {\n    \"id\": 1,\n    \"result\": null\n  }","ref":"Surrealix.Socket.html#use/3"},{"type":"function","title":"Surrealix.Socket.use/5","doc":"","ref":"Surrealix.Socket.html#use/5"},{"type":"type","title":"Surrealix.Socket.base_connection_opts/0","doc":"","ref":"Surrealix.Socket.html#t:base_connection_opts/0"},{"type":"type","title":"Surrealix.Socket.socket_opts/0","doc":"","ref":"Surrealix.Socket.html#t:socket_opts/0"}],"content_type":"text/markdown"}